diff --git a/test-display.c b/test-display.c
index 3391188..3c6df24 100644
--- a/test-display.c
+++ b/test-display.c
@@ -502,122 +730,74 @@ quit_cb (GtkWidget * win, gpointer unused)
     gtk_main_quit ();
 }
 
+static GtkToolItem *
+tool_button_new (const char *icon_name)
+{
+    GtkToolItem *toolitem;
+
+    toolitem = gtk_tool_button_new (NULL, NULL);
+    gtk_tool_button_set_icon_name (GTK_TOOL_BUTTON (toolitem), icon_name);
+    return toolitem;
+}
+
 static void
-populate_window (GtkWidget * win, ViewerCbInfo * info, int xid, gint win_width, gint win_height)
+populate_window (GtkWidget * win, 
+                 ViewerCbInfo * info, 
+                 cairo_surface_t *surface /* adopted */)
 {
     GtkWidget *vbox;
     GtkWidget *scroll;
-    gint img_width, img_height;
+    GtkWidget *toolbar;
+    GtkToolItem *toolitem;
 
     vbox = gtk_vbox_new (FALSE, 0);
     gtk_container_add (GTK_CONTAINER (win), vbox);
 
     /* create a new image */
-    info->image = gtk_image_new_from_pixbuf (info->pixbuf);
-
-    /* pack the window with the image */
-    img_width = gdk_pixbuf_get_width (info->pixbuf);
-    img_height = gdk_pixbuf_get_height (info->pixbuf);
-
-    if (xid <= 0) {
-		GtkWidget *toolbar;
-		GtkToolItem *toolitem;
-		GtkRequisition requisition;
-
-        toolbar = gtk_toolbar_new ();
-        gtk_box_pack_start (GTK_BOX (vbox), toolbar, FALSE, FALSE, 0);
+    info->image = rsvg_image_new_take_surface (surface);
 
-        toolitem = gtk_tool_button_new_from_stock (GTK_STOCK_ZOOM_IN);
-        gtk_toolbar_insert (GTK_TOOLBAR (toolbar), toolitem, 0);
-        g_signal_connect (G_OBJECT (toolitem), "clicked", G_CALLBACK (zoom_in), info);
+    toolbar = gtk_toolbar_new ();
+    gtk_box_pack_start (GTK_BOX (vbox), toolbar, FALSE, FALSE, 0);
 
-        toolitem = gtk_tool_button_new_from_stock (GTK_STOCK_ZOOM_OUT);
-        gtk_toolbar_insert (GTK_TOOLBAR (toolbar), toolitem, 1);
-        g_signal_connect (G_OBJECT (toolitem), "clicked", G_CALLBACK (zoom_out), info);
+    toolitem = tool_button_new ("zoom-in");
+    gtk_toolbar_insert (GTK_TOOLBAR (toolbar), toolitem, 0);
+    g_signal_connect (toolitem, "clicked", G_CALLBACK (zoom_in), info);
 
-		gtk_widget_size_request(toolbar, &requisition);
+    toolitem = tool_button_new ("zoom-out");
+    gtk_toolbar_insert (GTK_TOOLBAR (toolbar), toolitem, 1);
+    g_signal_connect (toolitem, "clicked", G_CALLBACK (zoom_out), info);
 
-		/* HACK: adjust for frame width & height + packing borders */
-		img_height += requisition.height + 30;
-		win_height += requisition.height + 30;
-		img_width  += 20;
-		win_width  += 20;
-    }
-
-    if ((xid > 0 && (img_width > win_width || img_height > win_height))
-        || (xid <= 0)) {
-        gtk_window_set_default_size (GTK_WINDOW (win), MIN (img_width, win_width),
-                                     MIN (img_height, win_height));
-
-        scroll = gtk_scrolled_window_new (NULL, NULL);
-        gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll),
-                                        GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
-        gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scroll), info->image);
-        gtk_box_pack_start (GTK_BOX (vbox), scroll, TRUE, TRUE, 0);
-    } else {
-        gtk_box_pack_start (GTK_BOX (vbox), info->image, TRUE, TRUE, 0);
-        gtk_window_set_default_size (GTK_WINDOW (win), img_width, img_height);
-    }
+    scroll = gtk_scrolled_window_new (NULL, NULL);
+    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll),
+                                    GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
+    gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (scroll), GTK_WIDGET (info->image));
+    gtk_box_pack_start (GTK_BOX (vbox), scroll, TRUE, TRUE, 0);
 }
 
 static void
-view_pixbuf (ViewerCbInfo * info, int xid, const char *color)
+view_surface (ViewerCbInfo * info, 
+              cairo_surface_t *surface /* adopted */,
+              const char *bg_color)
 {
     GtkWidget *win;
-    GdkColor bg_color;
-    gint win_width, win_height;
 
     /* create toplevel window and set its title */
 
-#ifdef ENABLE_XEMBED
-    if (xid > 0) {
-        GdkWindow *gdk_parent;
-
-        win = gtk_plug_new (0);
-
-        gdk_parent = gdk_window_foreign_new (xid);
-        gdk_window_get_geometry (gdk_parent, NULL, NULL, &win_width, &win_height, NULL);
-
-        /* so that button and key presses get registered */
-        gtk_widget_add_events (win, GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK);
-    } else
-#endif
-    {
-        char *title;
-
-        win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
-
-        win_width = DEFAULT_WIDTH;
-        win_height = DEFAULT_HEIGHT;
+    win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
 
-        if (info->id) {
-            title = g_strdup_printf ("%s#%s — %s", info->base_uri, info->id, _("SVG Viewer"));
-        } else {
-            title = g_strdup_printf ("%s — %s", info->base_uri,  _("SVG Viewer"));
-        }
-        gtk_window_set_title (GTK_WINDOW (win), title);
-        g_free (title);
-    }
+    populate_window (win, info, surface);
 
-    populate_window (win, info, xid, win_width, win_height);
+    /* exit when 'X' is clicked */
+    g_signal_connect (win, "destroy", G_CALLBACK (quit_cb), NULL);
+    g_signal_connect (win, "delete_event", G_CALLBACK (quit_cb), NULL);
 
-    rsvg_window_set_default_icon (GTK_WINDOW (win), info->pixbuf);
+    if (bg_color && strcmp (bg_color, "none") != 0) {
+        MyGdkRGBA rgba;
 
-    /* exit when 'X' is clicked */
-    g_signal_connect (G_OBJECT (win), "destroy", G_CALLBACK (quit_cb), NULL);
-    g_signal_connect (G_OBJECT (win), "delete_event", G_CALLBACK (quit_cb), NULL);
-
-    if (color && strcmp (color, "none") != 0) {
-        if (gdk_color_parse (color, &bg_color)) {
-            GtkWidget *parent_widget = gtk_widget_get_parent (info->image);
-
-            if (gdk_colormap_alloc_color
-                (gtk_widget_get_colormap (parent_widget), &bg_color, FALSE, TRUE))
-                gtk_widget_modify_bg (parent_widget, GTK_STATE_NORMAL, &bg_color);
-            else
-                g_warning (_("Couldn't allocate color '%s'"), color);
-        } else
-            g_warning (_("Couldn't parse color '%s'"), color);
+        if (my_gdk_rgba_parse (&rgba, bg_color))
+			rsvg_image_set_bg_color (info->image, rgba);
+        else
+            g_warning (_("Couldn't parse color '%s'"), bg_color);
     }
 
     create_popup_menu (info);
@@ -625,22 +805,17 @@ view_pixbuf (ViewerCbInfo * info, int xid, const char *color)
     info->window = win;
     gtk_window_add_accel_group (GTK_WINDOW (win), info->accel_group);
 
-    g_signal_connect (G_OBJECT (win), "button-press-event", G_CALLBACK (button_press_event), info);
+    g_signal_connect (win, "button-press-event", G_CALLBACK (button_press_event), info);
 
     gtk_widget_show_all (win);
 
-#ifdef ENABLE_XEMBED
-    if (xid > 0) {
-        XReparentWindow (GDK_WINDOW_XDISPLAY (win->window),
-                         GDK_WINDOW_XID (win->window), xid, 0, 0);
-        XMapWindow (GDK_WINDOW_XDISPLAY (win->window), GDK_WINDOW_XID (win->window));
-    }
-#endif
+    set_window_title (info);
 }
 
 int
 main (int argc, char **argv)
 {
+    int retval = 1;
     GError *err = NULL;
     GOptionContext *g_option_context;
     double x_zoom = 1.0;
@@ -652,22 +827,22 @@ main (int argc, char **argv)
     int bVersion = 0;
     char *bg_color = NULL;
     char *base_uri = NULL;
-    int bKeepAspect = 0;
+    gboolean keep_aspect_ratio = FALSE;
+    gboolean unlimited = FALSE;
     char *id = NULL;
+    GInputStream *input;
+    GFile *file, *base_file;
+    cairo_surface_t *surface;
 
-    int xid = -1;
     int from_stdin = 0;
     ViewerCbInfo info;
 
-    struct RsvgSizeCallbackData size_data;
+    RsvgHandleFlags flags = RSVG_HANDLE_FLAGS_NONE;
 
     char **args = NULL;
     gint n_args = 0;
 
     GOptionEntry options_table[] = {
-#ifdef ENABLE_XEMBED
-        {"xid", 'i', 0, G_OPTION_ARG_INT, &xid, N_("XWindow ID [for X11 embedding]"), N_("<int>")},
-#endif
         {"stdin", 's', 0, G_OPTION_ARG_NONE, &from_stdin, N_("Read from stdin instead of a file"),
          NULL},
         {"dpi-x", 'd', 0, G_OPTION_ARG_DOUBLE, &dpi_x, N_("Set the # of Pixels Per Inch"),
@@ -686,20 +861,20 @@ main (int argc, char **argv)
          N_("<string>")},
         {"id", 0, 0, G_OPTION_ARG_STRING, &id, N_("Only show one node (default: all)"),
          N_("<string>")},
-        {"keep-aspect", 'k', 0, G_OPTION_ARG_NONE, &bKeepAspect,
+        {"keep-aspect", 'k', 0, G_OPTION_ARG_NONE, &keep_aspect_ratio,
          N_("Preserve the image's aspect ratio"), NULL},
+        {"unlimited", 'u', 0, G_OPTION_ARG_NONE, &unlimited,
+         N_("Allow huge SVG files"), NULL},
         {"version", 'v', 0, G_OPTION_ARG_NONE, &bVersion, N_("Show version information"), NULL},
         {G_OPTION_REMAINING, 0, 0, G_OPTION_ARG_FILENAME_ARRAY, &args, NULL, N_("[FILE...]")},
         {NULL}
     };
 
 	/* Set the locale so that UTF-8 filenames work */
-	setlocale(LC_ALL, "");
+    setlocale(LC_ALL, "");
 
-    g_thread_init (NULL);
+    RSVG_G_TYPE_INIT;
 
-    info.pixbuf = NULL;
-    info.svg_bytes = NULL;
     info.window = NULL;
     info.popup_menu = NULL;
 
@@ -718,109 +893,104 @@ main (int argc, char **argv)
         return 0;
     }
 
-    if (args) {
-        while (args[n_args] != NULL)
-            n_args++;
-    }
+    if (args)
+        n_args = g_strv_length (args);
+    else
+        n_args = 0;
 
     if ((!from_stdin) && (n_args != 1)) {
-        g_print (_("No files specified, and not using --stdin\n"));
+        g_printerr (_("No files specified, and not using --stdin\n"));
         return 1;
     }
 
-    /* initialize gtk+ and rsvg */
-    rsvg_init ();
-
     rsvg_set_default_dpi_x_y (dpi_x, dpi_y);
 
-    /* if both are unspecified, assume user wants to zoom the pixbuf in at least 1 dimension */
-    if (width == -1 && height == -1) {
-        size_data.type = RSVG_SIZE_ZOOM;
-        size_data.x_zoom = x_zoom;
-        size_data.y_zoom = y_zoom;
-    }
-    /* if both are unspecified, assume user wants to resize pixbuf in at least 1 dimension */
-    else if (x_zoom == 1.0 && y_zoom == 1.0) {
-        size_data.type = RSVG_SIZE_WH;
-        size_data.width = width;
-        size_data.height = height;
-    }
-    /* assume the user wants to zoom the pixbuf, but cap the maximum size */
-    else {
-        size_data.type = RSVG_SIZE_ZOOM_MAX;
-        size_data.x_zoom = x_zoom;
-        size_data.y_zoom = y_zoom;
-        size_data.width = width;
-        size_data.height = height;
-    }
-
-    size_data.keep_aspect_ratio = bKeepAspect;
+    if (unlimited)
+        flags |= RSVG_HANDLE_FLAG_UNLIMITED;
 
-    if (!from_stdin) {
-        if (base_uri == NULL)
-            base_uri = (char *) args[0];
-
-        info.svg_bytes = _rsvg_acquire_xlink_href_resource (args[0], base_uri, NULL);
+    if (from_stdin) {
+#if 0 // defined (G_OS_UNIX)
+        input = g_unix_input_stream_new (STDIN_FILENO, FALSE);
+#else
+        input = NULL;
+        g_set_error_literal (&err, G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED,
+                             "Reading from stdin not supported");
+#endif
+        base_file = NULL;
     } else {
-        info.svg_bytes = g_byte_array_new ();
+        file = g_file_new_for_commandline_arg (args[0]);
+        input = (GInputStream *) g_file_read (file, NULL, &err);
 
-        for (;;) {
-            unsigned char buf[1024 * 8];
-            size_t nread = fread (buf, 1, sizeof (buf), stdin);
-
-            if (nread > 0)
-                g_byte_array_append (info.svg_bytes, buf, nread);
-
-            if (nread < sizeof (buf)) {
-                if (ferror (stdin)) {
-                    g_print (_("Error reading\n"));
-                    g_byte_array_free (info.svg_bytes, TRUE);
-                    fclose (stdin);
-
-                    return 1;
-                } else if (feof (stdin))
-                    break;
-            }
-        }
+        if (base_uri)
+            base_file = g_file_new_for_uri (base_uri);
+        else
+            base_file = g_object_ref (file);
 
-        fclose (stdin);
+        g_object_unref (file);
     }
 
-    if (!info.svg_bytes || !info.svg_bytes->len) {
-        g_print (_("Couldn't open %s\n"), args[0]);
+    g_strfreev (args);
+
+    if (input == NULL) {
+        g_printerr ("Failed to read input: %s\n", err->message);
+        g_error_free (err);
         return 1;
     }
 
-    info.base_uri = base_uri;
+    info.base_uri = base_file ? g_file_get_uri (base_file) : g_strdup ("");
     info.id = id;
+    info.x_zoom = x_zoom;
+    info.y_zoom = y_zoom;
+
+    info.handle = rsvg_handle_new_from_stream_sync (input, 
+                                                    base_file, 
+                                                    flags,
+                                                    NULL /* cancellable */,
+                                                    &err);
+    if (base_file != NULL)
+        g_object_unref (base_file);
+    g_object_unref (input);
+
+    if (info.handle == NULL) {
+        g_printerr ("Failed to load SVG: %s\n", err->message);
+        g_error_free (err);
+        return 1;
+    }
 
-    info.pixbuf = 
-        pixbuf_from_data_with_size_data (info.svg_bytes->data, info.svg_bytes->len, &size_data,
-                                         base_uri, id, &err);
-
-    if (!info.pixbuf) {
-        g_print (_("Error displaying image"));
-
-        if (err) {
-            g_print (": %s", err->message);
-            g_error_free (err);
-        }
+    rsvg_handle_get_dimensions (info.handle, &info.dimensions);
 
-        g_print ("\n");
+    if (width != -1) {
+        info.x_zoom = (double) width / info.dimensions.width;
+    } else {
+        info.x_zoom = x_zoom;
+    }
+    if (height != -1) {
+        info.y_zoom = (double) height / info.dimensions.height;
+    } else {
+        info.y_zoom = y_zoom;
+    }
 
-        return 1;
+    surface = render_to_surface (&info);
+    if (surface == NULL) {
+        g_printerr ("Unknown error while rendering image\n");
+        goto done;
     }
 
+    retval = 0;
+
     info.accel_group = gtk_accel_group_new ();
 
-    view_pixbuf (&info, xid, bg_color);
+    view_surface (&info, surface, bg_color);
 
     /* run the gtk+ main loop */
     gtk_main ();
 
-    g_object_unref (G_OBJECT (info.pixbuf));
-    g_byte_array_free (info.svg_bytes, TRUE);
-    rsvg_term ();
+  done:
+
+    g_free (info.base_uri);
+    g_object_unref (info.handle);
 
-    return 0;
+    rsvg_cleanup ();
+
+    return retval;
 }
